import 'package:test_helper/test_helper.dart';

void theory<TData>(List<TData> inlineData, void Function(TData data) theory) {
  inlineData.forEach(theory);
}

void theoryResult<TData, TResult>(List<TData> inlineData,
    List<TResult> expected, TResult Function(TData data) act) {
  final results = inlineData.map(act).toList();
  expectList(results, expected);
}

void theoryResultAsync<TData, TResult>(List<TData> inlineData,
    List<TResult> expected, Future<TResult> Function(TData data) act) async {
  final results = List<TResult>.empty(growable: true);
  for (var dataItem in inlineData) {
    final res = await act(dataItem);
    results.add(res);
  }
  //final results = inlineData.map((data) async => await act(data)).toList();
  expectList(results, expected);
}
